Index: drivers/ieee1394/sbp2.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/ieee1394/sbp2.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/ieee1394/sbp2.c	22 Jul 2004 19:50:25 -0000	1.1
+++ drivers/ieee1394/sbp2.c	4 Aug 2004 01:28:56 -0000	1.2
@@ -1379,7 +1180,7 @@
 
 	SBP2_DEBUG("sbp2_query_logins: orb byte-swapped");
 
-	sbp2util_packet_dump(scsi_id->query_logins_orb, sizeof(stuct sbp2_query_logins_orb),
+	sbp2util_packet_dump(scsi_id->query_logins_orb, sizeof(struct sbp2_query_logins_orb),
 			     "sbp2 query logins orb", scsi_id->query_logins_orb_dma);
 
 	memset(scsi_id->query_logins_response, 0, sizeof(struct sbp2_query_logins_response));
@@ -1474,6 +1275,8 @@
 	/* Set the lun if we were able to pull it from the device's unit directory */
 	if (scsi_id->sbp2_device_type_and_lun != SBP2_DEVICE_TYPE_LUN_UNINITIALIZED) {
 		scsi_id->login_orb->lun_misc |= ORB_SET_LUN(scsi_id->sbp2_device_type_and_lun);
+		SBP2_DEBUG("sbp2_query_logins: set lun to %d",
+			   ORB_SET_LUN(scsi_id->sbp2_device_type_and_lun));
 	}
 	SBP2_DEBUG("sbp2_login_device: lun_misc initialized");
 
@@ -1514,7 +1317,8 @@
 
 	atomic_set(&scsi_id->sbp2_login_complete, 0);
 
-	SBP2_DEBUG("sbp2_login_device: prepared to write");
+	SBP2_DEBUG("sbp2_login_device: prepared to write to %08x",
+		   (unsigned int)scsi_id->sbp2_management_agent_addr);
 	hpsb_node_write(scsi_id->ne, scsi_id->sbp2_management_agent_addr, data, 8);
 	SBP2_DEBUG("sbp2_login_device: written");
 
@@ -1625,8 +1429,14 @@
 
 	SBP2_INFO("Logged out of SBP-2 device");
 
-	return(0);
+#ifdef SBP2_USE_SCSI_ADDREM_HACK
+	/* Now that we are logged out of the SBP-2 device, lets
+	 * try to un-hook ourselves from the SCSI subsystem */
+	if (scsi_remove_single_device(hi->scsi_host, 0, scsi_id->id, 0))
+		SBP2_INFO("Unable to disconnect SBP-2 device from the SCSI subsystem");
+#endif
 
+	return 0;
 }
 
 /*
@@ -1745,50 +1555,50 @@
  * directory. Used to determine things like sbp2 management agent offset,
  * and command set used (SCSI or RBC). 
  */
-static void sbp2_parse_unit_directory(struct scsi_id_instance_data *scsi_id)
+static void sbp2_parse_unit_directory(struct scsi_id_group *scsi_group,
+				      struct unit_directory *ud)
 {
-	struct unit_directory *ud;
+	struct scsi_id_instance_data *scsi_id;
+	struct list_head *lh;
+	u64 management_agent_addr;
+	u32 command_set_spec_id, command_set, unit_characteristics,
+		firmware_revision, workarounds;
 	int i;
 
 	SBP2_DEBUG("sbp2_parse_unit_directory");
 
-	/* Initialize some fields, in case an entry does not exist */
-	scsi_id->sbp2_device_type_and_lun = SBP2_DEVICE_TYPE_LUN_UNINITIALIZED;
-	scsi_id->sbp2_management_agent_addr = 0x0;
-	scsi_id->sbp2_command_set_spec_id = 0x0;
-	scsi_id->sbp2_command_set = 0x0;
-	scsi_id->sbp2_unit_characteristics = 0x0;
-	scsi_id->sbp2_firmware_revision = 0x0;
-
-	ud = scsi_id->ud;
+	management_agent_addr = 0x0;
+	command_set_spec_id = 0x0;
+	command_set = 0x0;
+	unit_characteristics = 0x0;
+	firmware_revision = 0x0;
 
 	/* Handle different fields in the unit directory, based on keys */
 	for (i = 0; i < ud->length; i++) {
 		switch (CONFIG_ROM_KEY(ud->quadlets[i])) {
 		case SBP2_CSR_OFFSET_KEY:
 			/* Save off the management agent address */
-			scsi_id->sbp2_management_agent_addr =
+			management_agent_addr =
 				CSR_REGISTER_BASE + 
 				(CONFIG_ROM_VALUE(ud->quadlets[i]) << 2);
 
 			SBP2_DEBUG("sbp2_management_agent_addr = %x",
-				   (unsigned int) scsi_id->sbp2_management_agent_addr);
+				   (unsigned int) management_agent_addr);
 			break;
 
 		case SBP2_COMMAND_SET_SPEC_ID_KEY:
 			/* Command spec organization */
-			scsi_id->sbp2_command_set_spec_id
+			command_set_spec_id
 				= CONFIG_ROM_VALUE(ud->quadlets[i]);
 			SBP2_DEBUG("sbp2_command_set_spec_id = %x",
-				   (unsigned int) scsi_id->sbp2_command_set_spec_id);
+				   (unsigned int) command_set_spec_id);
 			break;
 
 		case SBP2_COMMAND_SET_KEY:
 			/* Command set used by sbp2 device */
-			scsi_id->sbp2_command_set
-				= CONFIG_ROM_VALUE(ud->quadlets[i]);
+			command_set = CONFIG_ROM_VALUE(ud->quadlets[i]);
 			SBP2_DEBUG("sbp2_command_set = %x",
-				   (unsigned int) scsi_id->sbp2_command_set);
+				   (unsigned int) command_set);
 			break;
 
 		case SBP2_UNIT_CHARACTERISTICS_KEY:
@@ -1796,10 +1606,10 @@
 			 * Unit characterisitcs (orb related stuff
 			 * that I'm not yet paying attention to)
 			 */
-			scsi_id->sbp2_unit_characteristics
+			unit_characteristics
 				= CONFIG_ROM_VALUE(ud->quadlets[i]);
 			SBP2_DEBUG("sbp2_unit_characteristics = %x",
-				   (unsigned int) scsi_id->sbp2_unit_characteristics);
+				   (unsigned int) unit_characteristics);
 			break;
 
 		case SBP2_DEVICE_TYPE_AND_LUN_KEY:
@@ -1807,21 +1617,29 @@
 			 * Device type and lun (used for
 			 * detemining type of sbp2 device)
 			 */
+			scsi_id = kmalloc(sizeof(*scsi_id), GFP_KERNEL);
+			if (!scsi_id) {
+				SBP2_ERR("Out of memory adding scsi_id, not all LUN's will be added");
+				break;
+			}
+			memset(scsi_id, 0, sizeof(*scsi_id));
+
 			scsi_id->sbp2_device_type_and_lun
 				= CONFIG_ROM_VALUE(ud->quadlets[i]);
 			SBP2_DEBUG("sbp2_device_type_and_lun = %x",
 				   (unsigned int) scsi_id->sbp2_device_type_and_lun);
+			list_add_tail(&scsi_id->list, &scsi_group->scsi_id_list);
 			break;
 
 		case SBP2_FIRMWARE_REVISION_KEY:
 			/* Firmware revision */
-			scsi_id->sbp2_firmware_revision
+			firmware_revision
 				= CONFIG_ROM_VALUE(ud->quadlets[i]);
 			if (sbp2_force_inquiry_hack)
 				SBP2_INFO("sbp2_firmware_revision = %x",
-				   (unsigned int) scsi_id->sbp2_firmware_revision);
+				   (unsigned int) firmware_revision);
 			else	SBP2_DEBUG("sbp2_firmware_revision = %x",
-				   (unsigned int) scsi_id->sbp2_firmware_revision);
+				   (unsigned int) firmware_revision);
 			break;
 
 		default:
@@ -1831,7 +1649,7 @@
 
 	/* This is the start of our broken device checking. We try to hack
 	 * around oddities and known defects.  */
-	scsi_id->workarounds = 0x0;
+	workarounds = 0x0;
 
 	/* If the vendor id is 0xa0b8 (Symbios vendor id), then we have a
 	 * bridge with 128KB max transfer size limitation. For sanity, we
@@ -1842,28 +1660,60 @@
 	 * host gets initialized. That way we can down-force the
 	 * sbp2_max_sectors to account for it. That is not currently
 	 * possible.  */
-	if ((scsi_id->sbp2_firmware_revision & 0xffff00) ==
+	if ((firmware_revision & 0xffff00) ==
 			SBP2_128KB_BROKEN_FIRMWARE &&
 			(sbp2_max_sectors * 512) > (128 * 1024)) {
 		SBP2_WARN("Node " NODE_BUS_FMT ": Bridge only supports 128KB max transfer size.",
-				NODE_BUS_ARGS(scsi_id->ne->nodeid));
+				NODE_BUS_ARGS(ud->ne->host, ud->ne->nodeid));
 		SBP2_WARN("WARNING: Current sbp2_max_sectors setting is larger than 128KB (%d sectors)!",
 				sbp2_max_sectors);
-		scsi_id->workarounds |= SBP2_BREAKAGE_128K_MAX_TRANSFER;
+		workarounds |= SBP2_BREAKAGE_128K_MAX_TRANSFER;
 	}
 
 	/* Check for a blacklisted set of devices that require us to force
 	 * a 36 byte host inquiry. This can be overriden as a module param
 	 * (to force all hosts).  */
 	for (i = 0; i < NUM_BROKEN_INQUIRY_DEVS; i++) {
-		if ((scsi_id->sbp2_firmware_revision & 0xffff00) ==
+		if ((firmware_revision & 0xffff00) ==
 				sbp2_broken_inquiry_list[i]) {
 			SBP2_WARN("Node " NODE_BUS_FMT ": Using 36byte inquiry workaround",
-					NODE_BUS_ARGS(scsi_id->ne->nodeid));
-			scsi_id->workarounds |= SBP2_BREAKAGE_INQUIRY_HACK;
+					NODE_BUS_ARGS(ud->ne->host, ud->ne->nodeid));
+			workarounds |= SBP2_BREAKAGE_INQUIRY_HACK;
 			break; /* No need to continue. */
 		}
 	}
+
+	/* If this is a logical unit directory entry, process the parent
+	 * to get the common values. */
+	if (ud->flags & UNIT_DIRECTORY_LUN_DIRECTORY) {
+		sbp2_parse_unit_directory(scsi_group, ud->parent);
+	} else {
+		/* If our list is empty, add a base scsi_id (happens in a normal
+		 * case where there is no logical_unit_number entry */
+		if (list_empty(&scsi_group->scsi_id_list)) {
+			scsi_id = kmalloc(sizeof(*scsi_id), GFP_KERNEL);
+			if (!scsi_id) {
+				SBP2_ERR("Out of memory adding scsi_id");
+				return;
+			}
+			memset(scsi_id, 0, sizeof(*scsi_id));
+
+			scsi_id->sbp2_device_type_and_lun = SBP2_DEVICE_TYPE_LUN_UNINITIALIZED;
+			list_add_tail(&scsi_id->list, &scsi_group->scsi_id_list);
+		}
+
+		/* Update the generic fields in all the LUN's */
+		list_for_each (lh, &scsi_group->scsi_id_list) {
+			scsi_id = list_entry(lh, struct scsi_id_instance_data, list);
+
+			scsi_id->sbp2_management_agent_addr = management_agent_addr;
+			scsi_id->sbp2_command_set_spec_id = command_set_spec_id;
+			scsi_id->sbp2_command_set = command_set;
+			scsi_id->sbp2_unit_characteristics = unit_characteristics;
+			scsi_id->sbp2_firmware_revision = firmware_revision;
+			scsi_id->workarounds = workarounds;
+		}
+	}
 }
 
 /*
@@ -1894,11 +1744,12 @@
 
 	/* Payload size is the lesser of what our speed supports and what
 	 * our host supports.  */
-	scsi_id->max_payload_size = min(hpsb_speedto_maxrec[scsi_id->speed_code],
+	scsi_id->max_payload_size = min(sbp2_speedto_max_payload[scsi_id->speed_code],
 					(u8)(((be32_to_cpu(hi->host->csr.rom[2]) >> 12) & 0xf) - 1));
 
-	SBP2_ERR("Node[" NODE_BUS_FMT "]: Max speed [%s] - Max payload [%u]",
-		 NODE_BUS_ARGS(scsi_id->ne->nodeid), hpsb_speedto_str[scsi_id->speed_code],
+	SBP2_ERR("Node " NODE_BUS_FMT ": Max speed [%s] - Max payload [%u]",
+		 NODE_BUS_ARGS(hi->host, scsi_id->ne->nodeid),
+		 hpsb_speedto_str[scsi_id->speed_code],
 		 1 << ((u32)scsi_id->max_payload_size + 2));
 
 	return(0);
@@ -1922,7 +1773,7 @@
 	packet = sbp2util_allocate_write_packet(hi, scsi_id->ne,
 						scsi_id->sbp2_command_block_agent_addr +
 						SBP2_AGENT_RESET_OFFSET,
-						4, &data);
+						4, &data, wait ? 0 : 1);
 
 	if (!packet) {
 		SBP2_ERR("sbp2util_allocate_write_packet failed");
@@ -1938,6 +1789,7 @@
 	if (wait) {
 		down(&packet->state_change);
 		down(&packet->state_change);
+		sbp2_free_packet(packet);
 	}
 
 	/*
@@ -2232,7 +2084,7 @@
 
 			packet = sbp2util_allocate_write_packet(hi, scsi_id->ne,
 								scsi_id->sbp2_command_block_agent_addr +
-								SBP2_ORB_POINTER_OFFSET, 8, NULL);
+								SBP2_ORB_POINTER_OFFSET, 8, NULL, 1);
 		
 			if (!packet) {
 				SBP2_ERR("sbp2util_allocate_write_packet failed");
@@ -2282,7 +2134,7 @@
 
 			packet = sbp2util_allocate_write_packet(hi, scsi_id->ne,
 					scsi_id->sbp2_command_block_agent_addr +
-					SBP2_DOORBELL_OFFSET, 4, &data);
+					SBP2_DOORBELL_OFFSET, 4, &data, 1);
 	
 			if (!packet) {
 				SBP2_ERR("sbp2util_allocate_write_packet failed");
@@ -2586,7 +2438,7 @@
  * This function deals with status writes from the SBP-2 device
  */
 static int sbp2_handle_status_write(struct hpsb_host *host, int nodeid, int destid,
-				    quadlet_t *data, u64 addr, unsigned int length, u16 fl)
+				    quadlet_t *data, u64 addr, size_t length, u16 fl)
 {
 	struct sbp2scsi_host_info *hi = NULL;
 	struct scsi_id_instance_data *scsi_id = NULL;
@@ -3053,28 +2905,27 @@
 			      int length, int hostno, int inout)
 {
 	Scsi_Device *scd;
-	struct Scsi_Host *host;
-	struct sbp2scsi_host_info *hi;
+	struct Scsi_Host *scsi_host;
+	struct hpsb_host *host;
 	char *pos = buffer;
 
 	/* if someone is sending us data, just throw it away */
 	if (inout)
 		return length;
 
-	for (host = scsi_hostlist; host; host = host->next)
-		if (host->host_no == hostno)
+	for (scsi_host = scsi_hostlist; scsi_host; scsi_host = scsi_host->next)
+		if (scsi_host->host_no == hostno)
 			break;
 
-	if (!host)  /* if we couldn't find it, we return an error */
+	if (!scsi_host)  /* if we couldn't find it, we return an error */
 		return -ESRCH;
 
-	hi = hpsb_get_hostinfo_bykey(&sbp2_highlevel, (unsigned long)host->hostt);
-	if (!hi) /* shouldn't happen, but... */
+	host = hpsb_get_host_bykey(&sbp2_highlevel, (unsigned long)scsi_host->hostt);
+	if (!host) /* shouldn't happen, but... */
 		return -ESRCH;
 
 	SPRINTF("Host scsi%d             : SBP-2 IEEE-1394 (%s)\n", hostno,
-		hi->host->driver->name);
-	SPRINTF("Driver version         : %s\n", version);
+		host->driver->name);
 
 	SPRINTF("\nModule options         :\n");
 	SPRINTF("  max_speed            : %s\n", hpsb_speedto_str[sbp2_max_speed]);
@@ -3082,9 +2933,9 @@
 	SPRINTF("  serialize_io         : %s\n", sbp2_serialize_io ? "yes" : "no");
 	SPRINTF("  exclusive_login      : %s\n", sbp2_exclusive_login ? "yes" : "no");
 
-	SPRINTF("\nAttached devices       : %s\n", host->host_queue ? "" : "none");
+	SPRINTF("\nAttached devices       : %s\n", scsi_host->host_queue ? "" : "none");
 
-	for (scd = host->host_queue; scd; scd = scd->next) {
+	for (scd = scsi_host->host_queue; scd; scd = scd->next) {
 		int i;
 
 		SPRINTF("  [Channel: %02d, Id: %02d, Lun: %02d]  ", scd->channel,
@@ -3117,7 +2968,7 @@
 }
 
 
-MODULE_AUTHOR("James Goodwin <jamesg@filanet.com>");
+MODULE_AUTHOR("Ben Collins <bcollins@debian.org>");
 MODULE_DESCRIPTION("IEEE-1394 SBP-2 protocol driver");
 MODULE_SUPPORTED_DEVICE(SBP2_DEVICE_NAME);
 MODULE_LICENSE("GPL");
@@ -3149,6 +3000,8 @@
 {
 	SBP2_DEBUG("sbp2_module_init");
 
+	printk(KERN_INFO "sbp2: %s\n", version);
+
 	/* Module load debug option to force one command at a time (serializing I/O) */
 	if (sbp2_serialize_io) {
 		SBP2_ERR("Driver forced to serialize I/O (serialize_io = 1)");
Index: drivers/ieee1394/sbp2.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/ieee1394/sbp2.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/ieee1394/sbp2.h	22 Jul 2004 19:50:25 -0000	1.1
+++ drivers/ieee1394/sbp2.h	4 Aug 2004 01:28:56 -0000	1.2
@@ -388,7 +388,6 @@
 	/*
 	 * Values pulled from the device's unit directory
 	 */
-	struct unit_directory *ud;
 	u32 sbp2_command_set_spec_id;
 	u32 sbp2_command_set;
 	u32 sbp2_unit_characteristics;
@@ -407,6 +406,8 @@
 	struct list_head sbp2_command_orb_inuse;
 	struct list_head sbp2_command_orb_completed;
 
+	struct list_head list;
+
 	/* Node entry, as retrieved from NodeMgr entries */
 	struct node_entry *ne;
 
@@ -417,6 +418,13 @@
 	u32 workarounds;
 };
 
+
+/* Describes a per-ud scsi_id group */
+struct scsi_id_group {
+	struct list_head scsi_id_list;
+};
+
+
 /*
  * Sbp2 host data structure (one per sbp2 host)
  */
@@ -461,21 +469,22 @@
 /*
  * IEEE-1394 core driver related prototypes
  */
-static void sbp2_add_host(struct hpsb_host *host);
+static struct sbp2scsi_host_info *sbp2_add_host(struct hpsb_host *host);
 static void sbp2_remove_host(struct hpsb_host *host);
 static int sbp2_probe(struct unit_directory *ud);
 static void sbp2_disconnect(struct unit_directory *ud);
 static void sbp2_update(struct unit_directory *ud);
 
-static int sbp2_start_device(struct sbp2scsi_host_info *hi, 
-			     struct unit_directory *ud);
+static int sbp2_start_ud(struct sbp2scsi_host_info *hi,
+			 struct unit_directory *ud);
+static int sbp2_start_device(struct scsi_id_instance_data *scsi_id);
 static void sbp2_remove_device(struct scsi_id_instance_data *scsi_id);
 
 #ifdef CONFIG_IEEE1394_SBP2_PHYS_DMA
 static int sbp2_handle_physdma_write(struct hpsb_host *host, int nodeid, int destid, quadlet_t *data,
-                                     u64 addr, unsigned int length, u16 flags);
+                                     u64 addr, size_t length, u16 flags);
 static int sbp2_handle_physdma_read(struct hpsb_host *host, int nodeid, quadlet_t *data,
-                                    u64 addr, unsigned int length, u16 flags);
+                                    u64 addr, size_t length, u16 flags);
 #endif
 
 /*
@@ -486,7 +495,7 @@
 static int sbp2_reconnect_device(struct scsi_id_instance_data *scsi_id); 
 static int sbp2_logout_device(struct scsi_id_instance_data *scsi_id); 
 static int sbp2_handle_status_write(struct hpsb_host *host, int nodeid, int destid,
-				    quadlet_t *data, u64 addr, unsigned int length, u16 flags);
+				    quadlet_t *data, u64 addr, size_t length, u16 flags);
 static int sbp2_agent_reset(struct scsi_id_instance_data *scsi_id, int wait);
 static int sbp2_create_command_orb(struct scsi_id_instance_data *scsi_id,
 				   struct sbp2_command_info *command,
@@ -502,7 +511,8 @@
 static unsigned int sbp2_status_to_sense_data(unchar *sbp2_status, unchar *sense_data);
 static void sbp2_check_sbp2_command(struct scsi_id_instance_data *scsi_id, unchar *cmd);
 static void sbp2_check_sbp2_response(struct scsi_id_instance_data *scsi_id, Scsi_Cmnd *SCpnt);
-static void sbp2_parse_unit_directory(struct scsi_id_instance_data *scsi_id);
+static void sbp2_parse_unit_directory(struct scsi_id_group *scsi_group,
+				      struct unit_directory *ud);
 static int sbp2_set_busy_timeout(struct scsi_id_instance_data *scsi_id);
 static int sbp2_max_speed_and_size(struct scsi_id_instance_data *scsi_id);
 
Index: drivers/ieee1394/video1394.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/ieee1394/video1394.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/ieee1394/video1394.c	22 Jul 2004 19:50:25 -0000	1.1
+++ drivers/ieee1394/video1394.c	4 Aug 2004 01:28:56 -0000	1.2
@@ -46,7 +46,7 @@
 
 #include "ieee1394.h"
 #include "ieee1394_types.h"
-#include "ieee1394_hotplug.h"
+#include "nodemgr.h"
 #include "hosts.h"
 #include "ieee1394_core.h"
 #include "highlevel.h"
@@ -216,6 +216,7 @@
 	d->frame_size = buf_size;
 	d->buf_size = PAGE_ALIGN(buf_size);
 	d->last_buffer = -1;
+	INIT_LIST_HEAD(&d->link);
 	init_waitqueue_head(&d->waitq);
 
 	/* Init the regions for easy cleanup */
@@ -594,7 +595,7 @@
 		it_prg[i].begin.status = 0;
 		
 		it_prg[i].data[0] = cpu_to_le32(
-			(SPEED_100 << 16) 
+			(IEEE1394_SPEED_100 << 16) 
 			| (/* tag */ 1 << 14)
 			| (d->channel << 8) 
 			| (TCODE_ISO_DATA << 4));
@@ -713,7 +714,7 @@
 		struct dma_iso_ctx *d;
 		int i;
 
-		if(copy_from_user(&v, (void *)arg, sizeof(v)))
+		if (copy_from_user(&v, (void *)arg, sizeof(v)))
 			return -EFAULT;
 
 		/* if channel < 0, find lowest available one */
@@ -810,7 +811,7 @@
 			      v.channel);
 		}
 
-		if(copy_to_user((void *)arg, &v, sizeof(v)))
+		if (copy_to_user((void *)arg, &v, sizeof(v)))
 			return -EFAULT;
 
 		return 0;
@@ -824,7 +825,7 @@
 		u64 mask;
 		struct dma_iso_ctx *d;
 
-		if(copy_from_user(&channel, (void *)arg, sizeof(int)))
+		if (copy_from_user(&channel, (void *)arg, sizeof(int)))
 			return -EFAULT;
 
 		if (channel<0 || channel>(ISO_CHANNELS-1)) {
@@ -860,7 +861,7 @@
 		struct video1394_wait v;
 		struct dma_iso_ctx *d;
 
-		if(copy_from_user(&v, (void *)arg, sizeof(v)))
+		if (copy_from_user(&v, (void *)arg, sizeof(v)))
 			return -EFAULT;
 
 		d = find_ctx(&ctx->context_list, OHCI_ISO_RECEIVE, v.channel);
@@ -924,7 +925,7 @@
 		struct dma_iso_ctx *d;
 		int i;
 
-		if(copy_from_user(&v, (void *)arg, sizeof(v)))
+		if (copy_from_user(&v, (void *)arg, sizeof(v)))
 			return -EFAULT;
 
 		d = find_ctx(&ctx->context_list, OHCI_ISO_RECEIVE, v.channel);
@@ -953,12 +954,12 @@
 			}
 
 #if 1
-			while(d->buffer_status[v.buffer]!=
+			while (d->buffer_status[v.buffer]!=
 			      VIDEO1394_BUFFER_READY) {
 				spin_unlock_irqrestore(&d->lock, flags);
 				interruptible_sleep_on(&d->waitq);
 				spin_lock_irqsave(&d->lock, flags);
-				if(signal_pending(current)) {
+				if (signal_pending(current)) {
 					spin_unlock_irqrestore(&d->lock,flags);
 					return -EINTR;
 				}
@@ -995,7 +996,7 @@
 		spin_unlock_irqrestore(&d->lock, flags);
 
 		v.buffer=i;
-		if(copy_to_user((void *)arg, &v, sizeof(v)))
+		if (copy_to_user((void *)arg, &v, sizeof(v)))
 			return -EFAULT;
 
 		return 0;
@@ -1007,7 +1008,9 @@
 		struct video1394_queue_variable qv;
 		struct dma_iso_ctx *d;
 
-		if(copy_from_user(&v, (void *)arg, sizeof(v)))
+		qv.packet_sizes = NULL;
+
+		if (copy_from_user(&v, (void *)arg, sizeof(v)))
 			return -EFAULT;
 
 		d = find_ctx(&ctx->context_list, OHCI_ISO_TRANSMIT, v.channel);
@@ -1019,12 +1022,22 @@
 		}
 		
 		if (d->flags & VIDEO1394_VARIABLE_PACKET_SIZE) {
+			unsigned int *psizes;
+			int buf_size = d->nb_cmd * sizeof(unsigned int);
+
 			if (copy_from_user(&qv, (void *)arg, sizeof(qv))) 
 				return -EFAULT;
-			if (!access_ok(VERIFY_READ, qv.packet_sizes, 
-				       d->nb_cmd * sizeof(unsigned int))) {
+
+			psizes = kmalloc(buf_size, GFP_KERNEL);
+			if (!psizes)
+				return -ENOMEM;
+
+			if (copy_from_user(psizes, qv.packet_sizes, buf_size)) {
+				kfree(psizes);
 				return -EFAULT;
 			}
+
+			qv.packet_sizes = psizes;
 		}
 
 		spin_lock_irqsave(&d->lock,flags);
@@ -1033,6 +1046,8 @@
 			PRINT(KERN_ERR, ohci->id, 
 			      "Buffer %d is already used",v.buffer);
 			spin_unlock_irqrestore(&d->lock,flags);
+			if (qv.packet_sizes)
+				kfree(qv.packet_sizes);
 			return -EFAULT;
 		}
 		
@@ -1086,6 +1101,10 @@
 				reg_write(ohci, d->ctrlSet, 0x1000);
 			}
 		}
+
+		if (qv.packet_sizes)
+			kfree(qv.packet_sizes);
+
 		return 0;
 		
 	}
@@ -1095,7 +1114,7 @@
 		struct video1394_wait v;
 		struct dma_iso_ctx *d;
 
-		if(copy_from_user(&v, (void *)arg, sizeof(v)))
+		if (copy_from_user(&v, (void *)arg, sizeof(v)))
 			return -EFAULT;
 
 		d = find_ctx(&ctx->context_list, OHCI_ISO_TRANSMIT, v.channel);
@@ -1112,10 +1131,10 @@
 			return 0;
 		case VIDEO1394_BUFFER_QUEUED:
 #if 1
-			while(d->buffer_status[v.buffer]!=
+			while (d->buffer_status[v.buffer]!=
 			      VIDEO1394_BUFFER_READY) {
 				interruptible_sleep_on(&d->waitq);
-				if(signal_pending(current)) return -EINTR;
+				if (signal_pending(current)) return -EINTR;
 			}
 #else
 			if (wait_event_interruptible(d->waitq, 
Index: drivers/input/Config.in
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/input/Config.in,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/input/Config.in	22 Jul 2004 19:50:13 -0000	1.1
+++ drivers/input/Config.in	4 Aug 2004 01:28:56 -0000	1.2
@@ -14,6 +14,7 @@
 fi
 dep_tristate '  Joystick support' CONFIG_INPUT_JOYDEV $CONFIG_INPUT
 dep_tristate '  Event interface support' CONFIG_INPUT_EVDEV $CONFIG_INPUT
+dep_tristate '  User level driver support' CONFIG_INPUT_UINPUT $CONFIG_INPUT
 dep_tristate '  MX1 touchscreen support' CONFIG_INPUT_MX1TS $CONFIG_INPUT_MOUSEDEV $CONFIG_ARCH_MX1ADS
 
 endmenu
Index: drivers/input/Makefile
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/input/Makefile,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/input/Makefile	22 Jul 2004 19:50:13 -0000	1.1
+++ drivers/input/Makefile	4 Aug 2004 01:28:56 -0000	1.2
@@ -25,6 +25,7 @@
 obj-$(CONFIG_INPUT_JOYDEV)	+= joydev.o
 obj-$(CONFIG_INPUT_EVDEV)	+= evdev.o
 obj-$(CONFIG_INPUT_MX1TS)	+= mx1ts.o
+obj-$(CONFIG_INPUT_UINPUT)	+= uinput.o
 
 # The global Rules.make.
 
Index: drivers/input/evdev.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/input/evdev.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/input/evdev.c	22 Jul 2004 19:50:13 -0000	1.1
+++ drivers/input/evdev.c	4 Aug 2004 01:28:56 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- * $Id: evdev.c,v 1.1 2004/07/22 19:50:13 joff Exp $
+ * $Id: evdev.c,v 1.2 2004/08/04 01:28:56 joff Exp $
  *
  *  Copyright (c) 1999-2001 Vojtech Pavlik
  *
Index: drivers/input/input.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/input/input.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/input/input.c	22 Jul 2004 19:50:13 -0000	1.1
+++ drivers/input/input.c	4 Aug 2004 01:28:56 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- * $Id: input.c,v 1.1 2004/07/22 19:50:13 joff Exp $
+ * $Id: input.c,v 1.2 2004/08/04 01:28:56 joff Exp $
  *
  *  Copyright (c) 1999-2001 Vojtech Pavlik
  *
@@ -422,7 +422,7 @@
 static int __init input_init(void)
 {
 	if (devfs_register_chrdev(INPUT_MAJOR, "input", &input_fops)) {
-		printk(KERN_ERR "input: unable to register char major %d", INPUT_MAJOR);
+		printk(KERN_ERR "input: unable to register char major %d\n", INPUT_MAJOR);
 		return -EBUSY;
 	}
 	input_devfs_handle = devfs_mk_dir(NULL, "input", NULL);
Index: drivers/input/joydev.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/input/joydev.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/input/joydev.c	22 Jul 2004 19:50:13 -0000	1.1
+++ drivers/input/joydev.c	4 Aug 2004 01:28:56 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- * $Id: joydev.c,v 1.1 2004/07/22 19:50:13 joff Exp $
+ * $Id: joydev.c,v 1.2 2004/08/04 01:28:56 joff Exp $
  *
  *  Copyright (c) 1999-2000 Vojtech Pavlik 
  *  Copyright (c) 1999 Colin Van Dyke 
Index: drivers/input/keybdev.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/input/keybdev.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/input/keybdev.c	22 Jul 2004 19:50:13 -0000	1.1
+++ drivers/input/keybdev.c	4 Aug 2004 01:28:56 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- * $Id: keybdev.c,v 1.1 2004/07/22 19:50:13 joff Exp $
+ * $Id: keybdev.c,v 1.2 2004/08/04 01:28:56 joff Exp $
  *
  *  Copyright (c) 1999-2000 Vojtech Pavlik
  *
@@ -154,16 +154,18 @@
 
 static struct input_handler keybdev_handler;
 
+static unsigned int ledstate = 0xff;
+
 void keybdev_ledfunc(unsigned int led)
 {
 	struct input_handle *handle;	
 
-	for (handle = keybdev_handler.handle; handle; handle = handle->hnext) {
+	ledstate = led;
 
+	for (handle = keybdev_handler.handle; handle; handle = handle->hnext) {
 		input_event(handle->dev, EV_LED, LED_SCROLLL, !!(led & 0x01));
 		input_event(handle->dev, EV_LED, LED_NUML,    !!(led & 0x02));
 		input_event(handle->dev, EV_LED, LED_CAPSL,   !!(led & 0x04));
-
 	}
 }
 
@@ -172,7 +174,8 @@
 	if (type != EV_KEY) return;
 
 	if (emulate_raw(code, down))
-		printk(KERN_WARNING "keyboard.c: can't emulate rawmode for keycode %d\n", code);
+		if(code < BTN_MISC)
+			printk(KERN_WARNING "keybdev.c: can't emulate rawmode for keycode %d\n", code);
 
 	tasklet_schedule(&keyboard_tasklet);
 }
@@ -201,7 +204,12 @@
 	input_open_device(handle);
 
 //	printk(KERN_INFO "keybdev.c: Adding keyboard: input%d\n", dev->number);
-	kbd_refresh_leds();
+
+	if (ledstate != 0xff) {
+		input_event(dev, EV_LED, LED_SCROLLL, !!(ledstate & 0x01));
+		input_event(dev, EV_LED, LED_NUML,    !!(ledstate & 0x02));
+		input_event(dev, EV_LED, LED_CAPSL,   !!(ledstate & 0x04));
+	}
 
 	return handle;
 }
Index: drivers/input/mousedev.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/input/mousedev.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/input/mousedev.c	22 Jul 2004 19:50:13 -0000	1.1
+++ drivers/input/mousedev.c	4 Aug 2004 01:28:56 -0000	1.2
@@ -1,5 +1,5 @@
 /*
- * $Id: mousedev.c,v 1.1 2004/07/22 19:50:13 joff Exp $
+ * $Id: mousedev.c,v 1.2 2004/08/04 01:28:56 joff Exp $
  *
  *  Copyright (c) 1999-2000 Vojtech Pavlik
  *
Index: drivers/isdn/Config.in
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/isdn/Config.in,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/isdn/Config.in	22 Jul 2004 19:49:55 -0000	1.1
+++ drivers/isdn/Config.in	4 Aug 2004 01:28:56 -0000	1.2
@@ -8,6 +8,7 @@
 if [ "$CONFIG_INET" != "n" ]; then
    bool '  Support synchronous PPP' CONFIG_ISDN_PPP
    if [ "$CONFIG_ISDN_PPP" != "n" ]; then
+      dep_bool     '    PPP filtering for ISDN' CONFIG_IPPP_FILTER $CONFIG_FILTER
       bool         '    Use VJ-compression with synchronous PPP' CONFIG_ISDN_PPP_VJ
       bool         '    Support generic MP (RFC 1717)' CONFIG_ISDN_MPP
       dep_tristate '    Support BSD compression' CONFIG_ISDN_PPP_BSDCOMP $CONFIG_ISDN
Index: drivers/isdn/isdn_audio.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/isdn/isdn_audio.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/isdn/isdn_audio.c	22 Jul 2004 19:49:55 -0000	1.1
+++ drivers/isdn/isdn_audio.c	4 Aug 2004 01:28:56 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: isdn_audio.c,v 1.1 2004/07/22 19:49:55 joff Exp $
+/* $Id: isdn_audio.c,v 1.2 2004/08/04 01:28:56 joff Exp $
  *
  * Linux ISDN subsystem, audio conversion and compression (linklevel).
  *
@@ -15,7 +15,7 @@
 #include "isdn_audio.h"
 #include "isdn_common.h"
 
-char *isdn_audio_revision = "$Revision: 1.1 $";
+char *isdn_audio_revision = "$Revision: 1.2 $";
 
 /*
  * Misc. lookup-tables.
Index: drivers/isdn/isdn_audio.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/isdn/isdn_audio.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/isdn/isdn_audio.h	22 Jul 2004 19:49:55 -0000	1.1
+++ drivers/isdn/isdn_audio.h	4 Aug 2004 01:28:56 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: isdn_audio.h,v 1.1 2004/07/22 19:49:55 joff Exp $
+/* $Id: isdn_audio.h,v 1.2 2004/08/04 01:28:56 joff Exp $
  *
  * Linux ISDN subsystem, audio conversion and compression (linklevel).
  *
Index: drivers/isdn/isdn_common.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/isdn/isdn_common.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/isdn/isdn_common.c	22 Jul 2004 19:49:55 -0000	1.1
+++ drivers/isdn/isdn_common.c	4 Aug 2004 01:28:56 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: isdn_common.c,v 1.1 2004/07/22 19:49:55 joff Exp $
+/* $Id: isdn_common.c,v 1.2 2004/08/04 01:28:56 joff Exp $
  *
  * Linux ISDN subsystem, common used functions (linklevel).
  *
@@ -44,7 +44,7 @@
 
 isdn_dev *dev;
 
-static char *isdn_revision = "$Revision: 1.1 $";
+static char *isdn_revision = "$Revision: 1.2 $";
 
 extern char *isdn_net_revision;
 extern char *isdn_tty_revision;
Index: drivers/isdn/isdn_common.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/isdn/isdn_common.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/isdn/isdn_common.h	22 Jul 2004 19:49:55 -0000	1.1
+++ drivers/isdn/isdn_common.h	4 Aug 2004 01:28:56 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: isdn_common.h,v 1.1 2004/07/22 19:49:55 joff Exp $
+/* $Id: isdn_common.h,v 1.2 2004/08/04 01:28:56 joff Exp $
  *
  * header for Linux ISDN subsystem
  * common used functions and debugging-switches (linklevel).
Index: drivers/isdn/isdn_concap.c
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/isdn/isdn_concap.c,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/isdn/isdn_concap.c	22 Jul 2004 19:49:55 -0000	1.1
+++ drivers/isdn/isdn_concap.c	4 Aug 2004 01:28:56 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: isdn_concap.c,v 1.1 2004/07/22 19:49:55 joff Exp $
+/* $Id: isdn_concap.c,v 1.2 2004/08/04 01:28:56 joff Exp $
  * 
  * Linux ISDN subsystem, protocol encapsulation
  *
Index: drivers/isdn/isdn_concap.h
===================================================================
RCS file: /cvsroot/ts-7200/dist/linux24/drivers/isdn/isdn_concap.h,v
retrieving revision 1.1
retrieving revision 1.2
diff -u -r1.1 -r1.2
--- drivers/isdn/isdn_concap.h	22 Jul 2004 19:49:55 -0000	1.1
+++ drivers/isdn/isdn_concap.h	4 Aug 2004 01:28:56 -0000	1.2
@@ -1,4 +1,4 @@
-/* $Id: isdn_concap.h,v 1.1 2004/07/22 19:49:55 joff Exp $
+/* $Id: isdn_concap.h,v 1.2 2004/08/04 01:28:56 joff Exp $
  *
  * Linux ISDN subsystem, protocol encapsulation
  *
